/****************************************************************************
**
** Copyright (C) 2011 Digia Plc
** All rights reserved.
** For any questions to Digia, please use contact form at http://qt.digia.com
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia nor the names of its contributors
**     may be used to endorse or promote products derived from this 
**     software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
** $QT_END_LICENSE$
** 
** Copyright (c) 2011 Nokia Corporation and/or its subsidiary(-ies).
**
****************************************************************************/

#ifndef WINDOW_H
#define WINDOW_H

#include <QWidget>

QT_BEGIN_NAMESPACE
class QAbstractItemModel;
class QCheckBox;
class QComboBox;
class QDateEdit;
class QGroupBox;
class QLabel;
class QLineEdit;
class QProgressBar;
class QTimer;
class QTreeView;
QT_END_NAMESPACE

class My_TreeView;
class MySortFilterProxyModel;

//! [0]
class Window : public QWidget
{
    Q_OBJECT

public:
    Window();

    void setSourceModel( QAbstractItemModel *p_Model );
    void Adjust_ColumnSize();

private slots:
    void textFilterChanged();
    void dateFilterChanged();
    void slot_Timer();

private:
    MySortFilterProxyModel *_proxyModel;

    QGroupBox *_sourceGroupBox;
    QGroupBox *_proxyGroupBox;
    QGroupBox *_Progress_GroupBox;

    QProgressBar *_ProgressBar;
    QTimer       *_MainTimer;

    My_TreeView *_sourceView;
    My_TreeView *_proxyView;

    QCheckBox *_filterCaseSensitivityCheckBox;
    QLabel    *_filterPatternLabel;
    QLabel    *_fromLabel;
    QLabel    *_toLabel;
    QLineEdit *_filterPatternLineEdit;
    QComboBox *_filterSyntaxComboBox;
    QDateEdit *_fromDateEdit;
    QDateEdit *_toDateEdit;
};
//! [0]

#endif
